
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>设计模式（一）——简单工厂模式 / 憋错料</title>

    <meta name="description" content="设计模式（一）——简单工厂模式 嵌入式linux 设计模式(一)--简单工厂模式 一.简单工厂模式简介 1.简单工厂模式 简单工厂模式(Factory Method Pattern)是属于创建型模式,又叫做静态工厂方法(Static Factory Method)模式,是通过专门定义一个类来负责创建其他类的实例,被创建的实例通常都具有共同的父类.简单工厂模式是由一个工厂对象决定创建出哪一种产品类的实例. 简单工厂模式的UML类图 工厂角色(Creator):是简单工厂模式的核心,由它负责创建所有的类的内部逻辑.工厂类必须能够被">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">设计模式（一）——简单工厂模式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1><strong>嵌入式linux 设计模式（一）——简单工厂模式</strong></h1>
<h2>一、<strong>简单工厂模式简介</strong></h2>
<h3><strong>1、简单工厂模式</strong></h3>
<p>简单工厂模式（Factory Method Pattern）是属于创建型模式，又叫做静态工厂方法（Static Factory Method）模式，是通过专门定义一个类来负责创建其他类的实例，被创建的实例通常都具有共同的父类。简单工厂模式是由一个工厂对象决定创建出哪一种产品类的实例。</p>
<p>简单工厂模式的UML类图</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEuNTFjdG8uY29tL3d5ZnMwMi9NMDIvODkvMDEvd0tpb0wxZ0V5YXl3SVViN0FBQVM0VGFqT0JJNDM5LnBuZw==.jpg" /></p>
<p>工厂角色（Creator）：是简单工厂模式的核心，由它负责创建所有的类的内部逻辑。工厂类必须能够被外界调用，创建所需要的产品对象。</p>
<p>抽象（Product）产品角色：简单工厂模式所创建的所有对象的父类，注意，父类可以是接口也可以是抽象类，它负责描述所有实例所共有的公共接口。</p>
<p>具体产品（Concrete Product）角色：简单工厂所创建的具体实例对象，这些具体的产品往往都拥有共同的父类。</p>
<h3>2、<strong>简单工厂模式分析</strong></h3>
<p>简单工厂模式解决的问题是如何去实例化一个合适的对象。</p>
<p>简单工厂模式的核心思想就是：有一个专门的类来负责创建实例的过程。</p>
<p>具体来说，把产品看着是一系列的类的集合，这些类是由某个抽象类或者接口派生出来的一个对象树。而工厂类用来产生一个合适的对象来满足客户的要求。</p>
<p>如果简单工厂模式所涉及到的具体产品之间没有共同的逻辑，那么我们就可以使用接口来扮演抽象产品的角色；如果具体产品之间有功能的逻辑或，我们就必须把这 些共同的东西提取出来，放在一个抽象类中，然后让具体产品继承抽象类。为实现更好复用的目的，共同的东西总是应该抽象出来的。</p>
<p>在实际的的使用中，抽闲产品和具体产品之间往往是多层次的产品结构，如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczEuNTFjdG8uY29tL3d5ZnMwMi9NMDAvODkvMDMvd0tpb20xZ0V5ZFNpVVprT0FBQWJTdUE4a3I4NDE1LnBuZw==.jpg" /></p>
<h3><strong>3、简单工厂模式</strong><strong>优点</strong></h3>
<p>工厂类是简单工厂式的关键，工厂类包含了必要的逻辑判断，根据外界给定的信息决定究竟应该创建哪个具体类的对象。通过使用工厂类，外界可以从直接创建具体产品对象的尴尬局面摆脱出来，仅仅需要负责“消费”对象就可以了。而不必管这些对象究竟如何创建及如何组织的，明确了各自的职责和权利，有利于整个<a href="http://baike.baidu.com/view/1317046.htm" rel="external nofollow noreferrer">软件体系结构</a>的优化。</p>
<p>在简单工厂模式中，客户端不再负责对象的创建，而是把这个责任丢给了工厂类，客户端值负责对象的调用，从而明确了各个类的职责（单一职责）。</p>
<h3><strong>4、简单工厂模式</strong><strong>缺点</strong></h3>
<p>由于工厂类集中了所有实例的创建逻辑，违反了<a href="http://baike.baidu.com/view/292136.htm" rel="external nofollow noreferrer">高内聚</a>责任分配原则，将全部创建逻辑集中到了一个工厂类中；工厂类所能创建的类只能是事先考虑到的，如果需要添加新的类，则就需要改变工厂类了。</p>
<p>当系统中的具体产品类不断增多时候，可能会出现要求工厂类根据不同条件创建不同实例的需求．这种对条件的判断和对具体产品类型的判断交错在一起，很难避免模块功能的蔓延，对系统的维护和扩展非常不利；</p>
<p>这些缺点在<a href="http://baike.baidu.com/view/1580263.htm" rel="external nofollow noreferrer">工厂方法模式</a>中得到了一定的克服。</p>
<p>由于这个工厂类负责所以的对象的创建，那么当子类不断增多的时候，我们就需要去修改工厂的代码，这样就违反了开闭原则。</p>
<h3><strong>5、简单工厂模式</strong><strong>使用场景</strong></h3>
<p>工厂类负责创建的对象比较少；</p>
<p>客户只知道传入工厂类的参数，对于如何创建对象（逻辑）不关心；</p>
<p>由于简单工厂很容易违反高内聚责任分配原则，因此一般只在很简单的情况下应用。</p>
<p>JDBC是SUN公司提供的一套数据库编程接口API，它利用Java语言提供简单、一致的方式来访问各种关系型数据库。Java程序通过JDBC可以执 行SQL语句，对获取的数据进行处理，并将变化了的数据存回数据库，因此，JDBC是Java应用程序与各种关系数据进行对话的一种机制。用JDBC进行 数据库访问时，要使用数据库厂商提供的驱动程序接口与数据库管理系统进行数据交互。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvODkvMDMvd0tpb20xZ0V5ZnFoTU5ndUFBQVpaNjU5c1BZMDc3LnBuZw==.jpg" /></p>
<h2>二、<strong>简单工厂模式实例</strong></h2>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvODkvMDEvd0tpb0wxZ0V5aG5TekxGWkFBQVRpRXloV1M0NjEyLnBuZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvODkvMDEvd0tpb0wxZ0V5am1RdklCSUFBRkRzdnlYdVZrOTg5LnBuZw==.jpg" /></p>
<p>代码实例：</p>
<pre>#include&nbsp;&lt;iostream&gt;
#include&nbsp;&lt;cstdlib&gt;
using&nbsp;namespace&nbsp;std;
//抽象产品类
class&nbsp;Operation
{
protected:
&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;numberA;
&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;numberB;
public:
&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;getA()
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;numberA;
&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;getB()
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;numberB;
&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;void&nbsp;setA(double&nbsp;number)
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;numberA&nbsp;=&nbsp;number;
&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;void&nbsp;setB(double&nbsp;number)
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;numberB&nbsp;=&nbsp;number;
&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;virtual&nbsp;double&nbsp;getResult()
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;ret&nbsp;=&nbsp;0;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;ret;
&nbsp;&nbsp;&nbsp;&nbsp;}
};
//具体产品类
class&nbsp;OperationAdd:public&nbsp;Operation
{
public:
&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;getResult()
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;ret&nbsp;=&nbsp;0;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ret&nbsp;=&nbsp;numberA&nbsp;+&nbsp;numberB;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;ret;
&nbsp;&nbsp;&nbsp;&nbsp;}
};
class&nbsp;OperationSub:public&nbsp;Operation
{
public:
&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;getResult()
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;ret&nbsp;=&nbsp;0;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ret&nbsp;=&nbsp;numberA&nbsp;-&nbsp;numberB;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;ret;
&nbsp;&nbsp;&nbsp;&nbsp;}
};
class&nbsp;OperationMul:public&nbsp;Operation
{
public:
&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;getResult()
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;ret&nbsp;=&nbsp;0;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ret&nbsp;=&nbsp;numberA&nbsp;*&nbsp;numberB;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;ret;
&nbsp;&nbsp;&nbsp;&nbsp;}
};
class&nbsp;OperationDiv:public&nbsp;Operation
{
public:
&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;getResult()
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;double&nbsp;ret&nbsp;=&nbsp;0;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;if(numberB&nbsp;!=&nbsp;0)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ret&nbsp;=&nbsp;numberA&nbsp;/&nbsp;numberB;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;ret;
&nbsp;&nbsp;&nbsp;&nbsp;}
};
//工厂类
class&nbsp;OperationFactory
{
public:
&nbsp;&nbsp;&nbsp;&nbsp;Operation&nbsp;*CreateOperation(char&nbsp;type)
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Operation&nbsp;*oper;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;switch(type)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;case&nbsp;‘+‘:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;oper&nbsp;=&nbsp;new&nbsp;OperationAdd;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;break;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;case&nbsp;‘-‘:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;oper&nbsp;=&nbsp;new&nbsp;OperationSub;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;break;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;case&nbsp;‘*‘:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;oper&nbsp;=&nbsp;new&nbsp;OperationMul;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;break;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;case&nbsp;‘/‘:
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;oper&nbsp;=&nbsp;new&nbsp;OperationDiv;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;break;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;oper;
&nbsp;&nbsp;&nbsp;&nbsp;}
};
//客户端使用
int&nbsp;main(int&nbsp;argc,&nbsp;char&nbsp;*argv[])
{
&nbsp;&nbsp;&nbsp;&nbsp;Operation&nbsp;*oper&nbsp;=&nbsp;NULL;
&nbsp;&nbsp;&nbsp;&nbsp;OperationFactory&nbsp;factory;
&nbsp;&nbsp;&nbsp;&nbsp;oper&nbsp;=&nbsp;factory.CreateOperation(‘*‘);
&nbsp;&nbsp;&nbsp;&nbsp;oper-&gt;setA(1);
&nbsp;&nbsp;&nbsp;&nbsp;oper-&gt;setB(3);
&nbsp;&nbsp;&nbsp;&nbsp;cout&lt;&lt;oper-&gt;getResult()&lt;&lt;endl;
&nbsp;&nbsp;&nbsp;&nbsp;if(oper&nbsp;!=&nbsp;NULL)
&nbsp;&nbsp;&nbsp;&nbsp;{
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;delete&nbsp;oper;
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;oper&nbsp;=&nbsp;NULL;
&nbsp;&nbsp;&nbsp;&nbsp;}
&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;0;
}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 10:45:51 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e8%ae%be%e8%ae%a1%e6%a8%a1%e5%bc%8f-%e7%ae%80%e5%8d%95%e5%b7%a5%e5%8e%82%e6%a8%a1%e5%bc%8f/" title="设计模式  简单工厂模式">设计模式  简单工厂模式</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>设计模式（一）——简单工厂模式的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/j4N1eo3.html" rel="bookmark">【设计模式】简单工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以面向对象的思想和简单工厂模式,写一个C++计算器程序,代码如下: #include &lt;iostream&gt; using namespace std; class Operation { public: Operation(double left, double right) { lhs = left; rhs = right; } const double GetLeft() const { return lhs; } const double GetRight() const { retur			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/v0kBDbM.html" rel="bookmark">设计模式之简单工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				设计模式之简单工厂模式 动机:         不暴露实例化逻辑来创建对象.通过公共的接口创建新的对象.         这是一个简单的实现,客户端需要一个product,但是client不直接使用new对象,而是通过提供需要的对象信息来找factory得到新的product.         这个factory实例化一个具体的product并返回(转化成抽象的类),client段使用这个抽象的类而不用考虑它具体的实现. 应用举例:        也许工厂模式是使用最多的模式之一.举个例子,一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AmoGK4.html" rel="bookmark">设计模式初探&mdash;简单工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为什么要学习设计模式? 可重用.可维护.可扩展.灵活性好 什么是简单工厂模式? 从设计模式的类型上来说,简单工厂模式是属于创建型模式,又叫做静态工厂方法(Static Factory Method)模式,但不属于23种GOF设计模式之一.简单工厂模式是由一个工厂对象决定创建出哪一种产品类的实例.简单工厂模式是工厂模式家族中最简单实用的模式,可以理解为是不同工厂模式的一个特殊实现. 简单工厂模式的好处? (1)将具体业务和实现进行分离 (2)将多个具体业务之间进行解耦 解决的问题? 单独的类来创造			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YXQ7vM.html" rel="bookmark">【幻化万千戏红尘】qianfengDay10-java基础学习：成员内部类、静态内部类、局部和匿名内部类，设计模式之简单工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				课程回顾: 接口:1.属性:public\static\final2.方法:public\abstract 多态:1.静态化(编译时)多态重载2.动态化(运行时)多态重写对象转型 1.向上转型 2.向下转型 今日内容:内部类:定义在类的内部的类1.成员内部类格式:[修饰符] class 类名 { }内部不能有静态的属性和方法,可以访问外部类的属性,也可以调用外部类的方法 在静态方法中的使用格式:外部类 外对象=new 外部类();成员内部类 对象名=外对象.new 成员内部类(); 2.静态内部			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPWDl14.html" rel="bookmark">iOS设计模式 - &lpar;3&rpar;简单工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS设计模式 - (3)简单工厂模式           by Colin丶 转载请注明出处:              http://blog.csdn.net/hitwhylz/article/details/40381721 一.简述 简单工厂模式(FACTORY),通过面向对象的封装,继承和多态来降低程序的耦合度.将一个具体类的实例化交给一个静态工厂方法来执行. 该模式中的角色包括: 工厂类(Simple Factory): 只包含了创建具体类的静态方法. 抽象产品(Product):			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xrD8k4.html" rel="bookmark">大话设计模式&lowbar;简单工厂模式&lpar;Java代码&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简单的描述:一个父类.多个子类,实例化那个子类由一个单独的工厂类来进行 图片摘自大话设计模式: 运算类: 1 package com.longsheng.simpleFactory; 2 3 public class Calculate { 4 5 private double firstNum; 6 private double secondNum; 7 8 public double getFirstNum() { 9 return firstNum; 10 } 11 12 public v			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mm9ddXM.html" rel="bookmark">设计模式初探&mdash;&mdash;简单工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习设计模式已经有一段时间了,&lt;大话&gt;也正看第二遍,可是却迟迟不敢下笔.算了,先拿简单的开刀吧. 简单工厂模式是设计模式中一种比较简单.基础的设计模式. 定义: 由一个工厂类根据传入的参数,动态决定应该创建哪一个产品类(这些产品类继承自一个父类或接口)的实例. 包含元素: 工厂(Creator)角色 简单工厂模式的核心,它负责实现创建所有实例的内部逻辑.工厂类可以被外界直接调用,创建所需的产品对象. 抽象产品(Product)角色 简单工厂模式所创建的所有对象的父类,它负责描述所有实例所共有的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pL2qK4.html" rel="bookmark">01&period;设计模式&lowbar;简单工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载自  http://www.cnblogs.com/zhili/p/SimpleFactory.html 一.引言 这个系列也是自己对设计模式的一些学习笔记,希望对一些初学设计模式的人有所帮助的,在上一个专题中介绍了单例模式,在这个专题中继续为大家介绍一个比较容易理解的模式--简单工厂模式. 二.简单工厂模式的介绍 说到简单工厂,自然的第一个疑问当然就是什么是简单工厂模式了? 在现实生活中工厂是负责生产产品的,同样在设计模式中,简单工厂模式我们也可以理解为负责生产对象的一个类, 我们平常编程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Qoave0.html" rel="bookmark">设计模式之简单工厂模式&lpar;Simply Factory&rpar;摘录</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从设计模式的类型上来说,简单工厂模式是属于创建型模式,又叫静态工厂方法(Static Factory Method)模式,但不属于23种GOF设计模式之一.简单工厂模式是由一个工厂对象决定创建出哪一种产品类的实例.简单工厂模式是工厂模式家族中最简单实用的模式,可以理解为是不同工厂模式的一个特殊实现. 简单工厂模式的实质是由一个工厂类根据传入的参数,动态决定应该创建哪一个产品类(这些产品类继承自一个父类或接口)的实例. 该模式中包含的角色及其职责:(1).工厂(Creator)角色:简单工厂模式的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWdAkB0.html" rel="bookmark">C&num;设计模式&lpar;2&rpar;&mdash;&mdash;简单工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.引言 这个系列也是自己对设计模式的一些学习笔记,希望对一些初学设计模式的人有所帮助的,在上一个专题中介绍了单例模式,在这个专题中继续为大家介绍一个比较容易理解的模式——简单工厂模式. 二.简单工厂模式的介绍 说到简单工厂,自然的第一个疑问当然就是什么是简单工厂模式了? 在现实生活中工厂是负责生产产品的,同样在设计模式中,简单工厂模式我们也可以理解为负责生产对象的一个类, 我们平常编程中,当使用”new”关键字创建一个对象时,此时该类就依赖与这个对象,也就是他们之间的耦合度高,当需求变化时,我			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r4JD9D0.html" rel="bookmark" class="title">丛林中的路</a>
					<div>
						总时间限制:  1000ms 内存限制:  65536kB 描述 热带岛屿Lagrishan的首领现在面临一个问题:几年前,一批外援资金被用于维护村落之间的道路,但日益繁茂的丛林无情的侵蚀着村民的道路 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/74QlYo3.html" rel="bookmark" class="title">js中查找相同的几种函数</a>
					<div>
						function findInArr(arr,num){ for(var i=0;i&lt;arr.length;i++){ if(arr[i]==num){ return true; } } ret ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5q8q0.html" rel="bookmark" class="title">android之ViewPager的使用</a>
					<div>
						XML代码 &lt;android.support.v4.view.ViewPager   ViewPager控件        android:layout_width=&quot;wrap_con ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgL8eO0.html" rel="bookmark" class="title">倒排表压缩算法</a>
					<div>
						倒排表内存放的都是整型数字,所以对倒排表的压缩其实就是对数字的压缩.而二进制数字都是存储在long(8byte) ,int(4byte),short(2byte)类型里面,这种存储方式最大的弊端就是每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02bxko0.html" rel="bookmark" class="title">央行货币超发为何掀不起恶性通胀？</a>
					<div>
						美国&lt;纽约时报&gt;5月11日刊登的一篇观点文章说,近年来,人民币一直走在外升内贬的路上,对于内贬的原因,不少人认为是央行货币超发造成的,货币超发本会导致恶性通货膨胀,但中国近两年来的CPI增 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KyKow4.html" rel="bookmark" class="title">检查sqlite数据库完整性</a>
					<div>
						最近遇到一个问题,用户数据丢失,拿到用户数据库文件以后,发现数据库损坏. database disk image is malformed 因此希望可以找到一种方法,可以检测出来数据库是否损坏,经过g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmDwqD4.html" rel="bookmark" class="title">第一次做网页客户端开发的体会</a>
					<div>
						实验室组织了一个软件设计大赛,考虑了很久,决定选择网页客户端开发,又考虑了很久,决定写汽车网页.无意中想到网页可能会因为网速,网页内容,电脑配置等原因而加载慢,而用户面对的就是一个空白页面,无趣,不耐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyjzJe0.html" rel="bookmark" class="title">Annotation&lpar;二&rpar;&mdash;&mdash;Hibernate中注解的开发</a>
					<div>
						在利用注解开发数据库持久层以前,需要学习一个规范JPA(Java Persistence API),这也是SUN公司提出的数据库的持久化规范.就类似于JDBC,Servlet,JSP等规范一样.而Hi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/415qQP4.html" rel="bookmark" class="title">使用ndk-build编译生成&period;so文件</a>
					<div>
						前言:以下都是基于懂得Android开发.jni的使用以及搭建好ndk开发环境的基础上. 在Android开发中经常会使用到jni,当安装了ndk环境后就拥有了编译c/c++文件的能力. 经常在ecl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qvjbG4.html" rel="bookmark" class="title">RAID技术</a>
					<div>
						磁盘阵列 1. mdadm -C /dev/md0 -a yes -l 1 -n 2 -x 1 /dev/vdb{1..3} 创建名为/dev/md0的md设备 options: 1)  -C:创建m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xrKgz4.html" rel="bookmark" class="title">XML 数据岛</a>
					<div>
						微软从IE5开始将数据岛技术引入到浏览器中.通过使用数据岛,可以轻松的将Xml数据绑定到HTML中,这样就省去了手工填充数据的麻烦.另外,当改变Xml的数据时,绑定的数据也会随着Xml的改变而改变.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wEwjZM.html" rel="bookmark" class="title">python运维开发&lpar;十三&rpar;----SQLalchemy和paramiko续</a>
					<div>
						内容目录: ORM架构SQLalchemy Paramiko SQLalchemy对表的操作 使用 ORM/Schema Type/SQL Expression Language/Engine/Con ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoaVgQ3.html" rel="bookmark" class="title">oracle对表进行增删查改的操作，以及对用户的一些简单的操作</a>
					<div>
						1.验证数据库是否已经成功安装 select status from v$instance    status会显示open 2.如何oracle数据库中退回到操作系统中 exit 3.登录oracl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqvak0.html" rel="bookmark" class="title">目标可能并没有那么远</a>
					<div>
						兄弟连,真是一个比我想象中要严格的地方.这里和我所理解的就业培训机构完全不同,也许,这里更倾向于学校.紧张的课程进度,严肃的管理体系.拿着这本学生手册,我还是有点压力的.但是,毕竟已经是踏入社会一年多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyQBZmM.html" rel="bookmark" class="title">CSS 相邻选择器&lpar;七&rpar;</a>
					<div>
						一.相邻选择器 相邻选择器前后部分之间用一个加号(+)隔开,前后两部分选择反符在结构上属于同级关系,如 相邻选择器,是根据左侧选择符指定相邻元素,然后在该相邻元素后面寻找匹配匹配右侧选择符的相信元素  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbEvvM.html" rel="bookmark" class="title">四个重要 &lpar;2011-07-31 09&colon;47&colon;21&rpar;</a>
					<div>
						未来比今天更重要: 前途比现在更重要: 积极比安稳更重要: 学习比金钱更重要.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBZDn4.html" rel="bookmark" class="title">前端开发面试题收集&lpar;html部分&rpar;</a>
					<div>
						1.问:&lt;keygen&gt;是正确的HTML5标签吗? 答:是. &lt;keygen&gt; 标签规定用于表单的密钥对生成器字段.当提交表单时,私钥存储在本地,公钥发送到服务器. 2.问:& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRrNK0.html" rel="bookmark" class="title">蓝懿教育九月十九日记录</a>
					<div>
						1.本地地址解析 NSString*path =@&quot;/Users/ivan/Desktop/movie.txt&quot;; //表示二进制的对象    NSData *data = [NS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLRYlv3.html" rel="bookmark" class="title">datable的一些用法</a>
					<div>
						手动给DataTable添加数据 DataTable tab = new DataTable(); tab.Columns.Add(&quot;id&quot;, typeof(int));//添加列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QoZoB0.html" rel="bookmark" class="title">HDU 2068 RPG错排 错排公式</a>
					<div>
						1.题意:1到N的序列的排列中,元素位置与元素值相对应的情况(值为i的元素在某个排列中正好排在第i个位置)大于等于序列规模一半的情况,有多少个? 2.输入输出:每组数据一个数,N,规定输入以0结尾:  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
